<template>
  <div class="use-new-color-config">
    <div class="py-0 px-4 ml-0 relative my-0 mx-auto max-w-full w-full">
      <div class="overflow-hidden pt-8 py-4 px-0 pb-20 min-h-[calc(50vh-72px)] login-form-bg">
        <div class="my-0 mx-auto w-[1200px]">
          <div class="bg-background5 rounded-t-2xl">
            <div class="h-16 flex items-center py-0 pl-10 pr-4">
              <h1 class="text-left text-2xl leading-[28px] font-semibold text-[var(--secondary)]">{{ $t('capital_login') }}</h1>
            </div>
          </div>
          <div class="w-full h-[2px] bg-border"></div>
          <el-col class="w-[400px] py-6 px-10 bg-background5 h-[600px] overflow-hidden">
            <el-form
              ref="loginFormRef"
              label-position="left"
              :model="loginFormData"
              :rules="loginRules"
              :validate-on-rule-change="false"
            >
              <el-form-item :label="$t('username')" prop="Username">
                <el-input
                  v-model="loginFormData.Username"
                  :placeholder="$t('username')"
                  type="text"
                />
              </el-form-item>
              <el-form-item :label="$t('password')" prop="Password">
                <el-input
                  v-model="loginFormData.Password"
                  :placeholder="$t('password')"
                  type="password"
                />
              </el-form-item>
              <div
                v-if="!clientCaptcha.IsHidden"
                class="btn-click-captcha-to-verify"
              >
                <el-form-item prop="Captcha" :show-message="true" label="">
                  <div id="captcha-button">
                    <div id="captcha-pop-up-verify" class="w-full">
                      <template
                        v-if="
                          !captchaErrorMsg.length &&
                          loginFormData.Captcha.length == 5 &&
                          !isDialogVisible
                        "
                      >
                        <div class="relative w-[18px] h-[18px]">
                          <img
                            :src="
                              getAssetImage(
                                'assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png'
                              )
                            "
                            alt="verify icon success"
                            loading="lazy"
                          />
                        </div>
                        <span class="whitespace-nowrap">{{
                          $t("successful_verification")
                        }}</span>
                      </template>
                      <template v-else>
                        <div
                          class="flex justify-center items-center gap-1 w-full"
                          @click="isDialogVisible = true"
                        >
                          <div class="relative w-[18px] h-[18px]">
                            <img
                              :src="
                                getAssetImage(
                                  'assets/theme/light_flexible_1/desktop/images/menu/capcha.png'
                                )
                              "
                              alt="verify icon"
                              loading="lazy"
                            />
                          </div>
                          <span>{{ $t("click_to_verify") }}</span>
                        </div>
                      </template>
                    </div>
                  </div>
                </el-form-item>
              </div>
              <div class="h-[1px] bg-[var(--border)] w-full my-6" ></div>
              <template class="flex justify-center">
                <div class="w-full">
                  <el-button
                    class="px-4 py-1 text-sm w-full rounded btn bg-secondary text-center"
                    :disabled="isLoginProccessing"
                    type="danger"
                    round
                    @click="submitLogin(loginFormRef)"
                    >{{ $t("capital_login") }}</el-button
                  >
                </div>
              </template>
              <el-form-item class="forgot-password-form-item">
                <auth-forgot-password-modal />
              </el-form-item>
              <div
                v-if="!register.IsHidden"
                class="w-full text-xs text-[#707585] text-center fc-text4"
              >
                {{ $t("you_do_not_have_account_yet") }} ?
                <nuxt-link
                  class="underline text-[var(--accent-color)] relative hover:text-[var(--accent-color-light)] focus:text-[var(--accent-color-light)]"
                  to="/register"
                  :id="ID.SIGNUP">
                  {{ $t("create_account") }}
                </nuxt-link>
              </div>
            </el-form>
          </el-col>
          <el-col class="relative register-info w-[800px] h-[600px] flex flex-col justify-center text-center ol-bg-light">
            <div class="text-center flex flex-col items-center">
              <div class="w-[600px] h-[400px]">
                <img :src="loginRegister.ImagePath" class="w-full h-full object-contain" />
              </div>
              <div class="text-primary text-2xl font-black mb-1">
                <span>{{ $t('welcome_to') }}</span>
                <span v-if="!companyName.IsHidden" class="font-black text-[32px] fc-text4 ml-1">{{ companyName.Text }}</span>
              </div>
              <div class="text-base fc-text4">{{ $t(loginRegister.Text) }}</div>
            </div>
          </el-col>
        </div>
      </div>
    </div>
    <div class="captcha-dialog-container">
      <el-dialog
        v-model="isDialogVisible"
        align-center
        destroy-on-close
        :show-close="false"
        custom-class="p-[15px] captcha-dialog"
        width="320px"
        @open="loginFormData.Captcha = ''"
        @close="loginFormRef?.validateField('Captcha')"
      >
        <utils-client-captcha
          v-if="!clientCaptcha.IsHidden"
          v-model:captcha="loginFormData.Captcha"
          v-model:dialogVisible="isDialogVisible"
          :get-error-message="getCaptchaErrorMsg"
          :is-invalid="captchaErrorMsg.length > 0"
        />
      </el-dialog>
    </div>
  </div>
</template>

<script lang="ts" setup>
import useLogin from "@/composables/useLogin";
import commonHelper from "@/utils/commonHelper";
import { clientCaptcha } from "@/composables/captcha/useCaptcha";
import { store } from "~~/store";
import { IThemePropertiesFromApi } from "~~/models/companyThemePropertiesRespone";
const {
  loginFormRef,
  loginFormData,
  loginRules,
  submitLogin,
  isLoginProccessing,
  captchaErrorMsg,
  getCaptchaErrorMsg,
  register,
} = useLogin();
const { getAssetImage } = commonHelper;
const themeProperties = computed(
() => store.state.companyThemePropertiesFromApi.ThemeProperties
);
const loginRegister = computed(
(): IThemePropertiesFromApi =>
  themePropertyHelper.getSingleThemeProperty(
    themeProperties.value,
    "login_register"
  )
);
const darkBackground = `url(${getAssetImage(
  "assets/theme/black_modern_1/fonts/bg_page-user-form.svg"
)}`;
const lightBackground = `url(${getAssetImage(
  "assets/theme/black_modern_1/fonts/bg_page-user-form_1.svg"
)}`;
const companyName = computed(
(): IThemePropertiesFromApi =>
  themePropertyHelper.getSingleThemeProperty(
    themeProperties.value,
    "login_register_company_name"
  )
);
const isDialogVisible = ref(false);
watch(
  () => isDialogVisible.value,
  () => {
    const sidebar: HTMLElement | null = document.querySelector(
      'div[layout="modern"] aside.el-aside'
    );

    if (!sidebar) return;
    if (isDialogVisible.value) {
      sidebar.style.opacity = "0";
      sidebar.style.pointerEvents = "none";
      return;
    }
    sidebar.style.opacity = "1";
    sidebar.style.pointerEvents = "all";
  }
);
</script>

<style scoped>
.register-info {
  --bg-base-color: var(--background5);
  --bg-opacity: 5%;
}
.login-form-bg {
  background: v-bind("lightBackground") no-repeat;
  background-size: 620px;
}
html.dark .login-form-bg {
  background: v-bind("darkBackground") no-repeat;
  background-size: 620px;
}
.login-form-wrapper {
  background: var(--background2);
  box-shadow: var(--box-shadow);
  padding: 40px 30px;
  position: relative;
}
.login-form-wrapper h2 {
  color: var(--text);
}
:deep(.el-input) {
  display: flex;
  justify-content: flex-end;
}
:deep(.el-input__inner) {
  height: 32px;
  width: 100%;
  padding: 8px;
  font-family: Roboto, sans-serif;
  font-size: 14px;
  font-weight: 400;
  line-height: 20px;
  color: var(--text5);
  background: var(--background5);
  box-shadow: none;
  border-radius: 4px;
  box-sizing: border-box;
  border: 1px solid var(--border);
}
:deep(button.el-button) {
  height: 32px;
  border-radius: 4px;
  padding: 8px 15px;
  background-color: var(--secondary) !important;
  color: var(--textBtn) !important;
  text-align: center;
  font-weight: 700;
  border: none;
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4;
}
.el-form-item {
  display: block;
  margin-bottom: 16px;
}
.text-primary {
  color: var(--primary);
}
:deep(.forgot-password-form-item .el-form-item__content) {
  margin: 0;
  justify-content: center;
}
:deep(.el-form-item__label) {
  color: var(--text5);
}
.el-divider--horizontal {
  margin: 0 0 16px 0;

}
.forgot-password-form-item {
  margin: 4px 0 4px 0;
}
</style>
